"""
This is the template for coding tasks in exercise sheet 3.

Everywhere you see "YOUR CODE", it means a playground for you :P

WARNING: do not rename variables as this will break the tests.
=============================================================================================================================

Eventually you will explore the powerful least squares estimation formulated with linear algebra!
And as usual here are two functions that might be helpful to you.

- to stack vectors as columns to form a matrix:
    <https://numpy.org/doc/stable/reference/generated/numpy.column_stack.html>

- to calculate x = A^(-1) b with specifying A, b:
    <https://numpy.org/doc/stable/reference/generated/numpy.linalg.solve.html>

Have fun!
"""


import matplotlib.pyplot as plt
import numpy as np


## load data
data = np.load("exercise3_task4_dataset.npz")
i1 = data['i1']
u1 = data['u1']
i2 = data['i2']
u2 = data['u2']
N = 2000


## a) Plot each dataset in a corresponding plot
plt.figure(1)
plt.subplot(2,1,1)
# YOUR CODE: plot dataset i1, u1

plt.subplot(2,1,2)
# YOUR CODE: plot dataset i2, u2


## b) only PAPER questions :)


## c) 
# Use the least squares estimator to find the experimental values of R and E for each of the two datasets individually.
# YOUR CODE: least squares with dataset i1, u1
# ============================================
# "None" is just to pass the syntax check. Replace them with your code. Don't need to stick to a single line.
# (The same holds for all the following cases)
Phi1 = None
theta_star1 = None

# YOUR CODE: least squares with dataset i2, u2
Phi2 = None
theta_star2 = None


# Plot the linear fits through the respective measurement data
plt.figure(1)
plt.subplot(2,1,1)
# YOUR CODE: linear fits with dataset i1, u1

plt.subplot(2,1,2)
# YOUR CODE: linear fits with dataset i2, u2


## d) 
# YOUR CODE: calculate the residuals
r1 = None
r2 = None

# plot the histograms of them
plt.figure(2)
plt.subplot(1,2,1)
# YOUR CODE

plt.subplot(1,2,2)
# YOUR CODE


# show all plots
# ===============
# If you don't see any plots but also no errors, it is very likely because a non-interactive backend is chosen by default.
# One possible solution you can try is to manually select another backend via "matplotlib.use()" function at the beginning.
# Here gives more details: <https://matplotlib.org/stable/users/explain/backends.html>
plt.show()
